 //+------------------------------------------------------------------+
//|                                     EMA-alert-Symbol-Period.mq4  |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property show_inputs

#import "user32.dll"
int      PostMessageA(int hWnd,int Msg,int wParam,int lParam);
int      GetWindow(int hWnd,int uCmd);
int      GetParent(int hWnd);
#import


//---- input parameters
extern string  modo_info0 = "0 Media Mobile Semplice";
extern string  modo_info1 = "1 Media Mobile Esponenziale";
extern string  modo_info2 = "2 Media Mobile di Tipo Smoothed";
extern string  modo_info3 = "3 Media Mobile lineare Ponderata";
extern string  Prezzo_info0 = "0 Chiusura";
extern string  Prezzo_info1 = "1 Apertura";
extern string  Prezzo_info2 = "2 Massimo";
extern string  Prezzo_info3 = "3 Minimo";
extern string  Prezzo_info4 = "4 Media (Max+Min)/2";
extern string  Prezzo_info5 = "5 Tipico (Max+Min+Close)/3";
extern string  Prezzo_info6 = "6 Pesato (Max+Min+Close+Close)/4";
extern int ma_periodo = 34;
extern int ma_mode   = 1;
extern int ma_prezzo  = 0;
extern int ma_shift  = 0;
//extern int ma_periodo1 = 34;
//extern int ma_mode1   = 1;
//extern int ma_prezzo1  = 0;
//extern int ma_shift1  = 0;
//---- buffers

extern bool Box_Alert    =true;
extern bool Sound_Alert  =true;
extern bool Cambio_TF    =true;
extern int pip_distance  = 10;
datetime lastimealert;
datetime lastimealert1;
//----
double ema_value;
double ema_value1;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
int WaitTime = 1;
static int TimeSent;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  
    SetIndexBuffer(0, ExtMapBuffer1);
    SetIndexBuffer(1, ExtMapBuffer2);

//---- name for DataWindow and indicator subwindow label
  
//----
   
    return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
//----
   
   string MA,MA1;
   
   
    for(int i = 0; i < limit; i++)
      {
       ema_value= iMA(NULL,PERIOD_M1,ma_periodo,ma_shift,ma_mode,ma_prezzo,i);
       
       if(ma_mode==0){MA="SMA";}
       if(ma_mode==1){MA="EMA";}
       if(ma_mode==2){MA="SMMA";}
       if(ma_mode==3){MA="LWMA";}
        //----
        ExtMapBuffer1[i] = ema_value-Ask ;
        if(MathAbs(ema_value-Bid)<=pip_distance*Point&& TimeCurrent() >= TimeSent  + 10) 
            {
            
            if(Box_Alert) Alert(Symbol()," M",Period()," Price is within ",pip_distance," pips of ",ma_periodo," Period "+MA+"");
            if(Sound_Alert) PlaySound("alert2");
            //Esecuzione Cambio TF
            if(Cambio_TF)
           // bool blnContinue = true;   
            int intParent = GetParent( WindowHandle( Symbol(), Period() ) );   
            int intCmd; 
   
             switch( PERIOD_M1 )
            {
               case PERIOD_M1:   intCmd = 33137;  
             //  case PERIOD_M5:   intCmd = 33138;  break;                                        
             //  case PERIOD_M15:  intCmd = 33139;  break;
             //  case PERIOD_M30:  intCmd = 33140;  break;
             //  case PERIOD_H1:   intCmd = 35400;  break;
             //  case PERIOD_H4:   intCmd = 33136;  break;
             //  case PERIOD_D1:   intCmd = 33134;  break;
             //  case PERIOD_W1:   intCmd = 33141;  break;
             //  case PERIOD_MN1:  intCmd = 33334;  break;
             }
        
            PostMessageA( intParent, 0x0111, intCmd, 0 );                         
            TimeSent= TimeCurrent();
            }
            
            
       
       ema_value= iMA(NULL,PERIOD_M5,ma_periodo,ma_shift,ma_mode,ma_prezzo,i);
       
       if(ma_mode==0){MA="SMA";}
       if(ma_mode==1){MA="EMA";}
       if(ma_mode==2){MA="SMMA";}
       if(ma_mode==3){MA="LWMA";}
        //----
        ExtMapBuffer1[i] = ema_value-Ask ;
        if(MathAbs(ema_value-Bid)<=pip_distance*Point&& TimeCurrent() >= lastimealert1 + 10 )
            {
            
            if(Box_Alert) Alert(Symbol()," M",PERIOD_M1," Price is within ",pip_distance," pips of ",ma_periodo," Period "+MA+"");
            if(Sound_Alert) PlaySound("alert2");
            lastimealert1= TimeCurrent();
            
           // if(Cambio_TF)
          //  bool blnContinue1 = true;   
          //  int intParent1 = GetParent( WindowHandle( Symbol(), Period() ) );   
          //  int intCmd1; 
   
          //   switch( PERIOD_M5 )
         //   {
             //  case PERIOD_M1:   intCmd = 33137;  break;
         //     case PERIOD_M5:   intCmd1 = 33138;                                          
             //  case PERIOD_M15:  intCmd = 33139;  break;
             //  case PERIOD_M30:  intCmd = 33140;  break;
             //  case PERIOD_H1:   intCmd = 35400;  break;
             //  case PERIOD_H4:   intCmd = 33136;  break;
             //  case PERIOD_D1:   intCmd = 33134;  break;
             //  case PERIOD_W1:   intCmd = 33141;  break;
             //  case PERIOD_MN1:  intCmd = 33334;  break;
             //}
        
        //    PostMessageA( intParent1, 0x0111, intCmd1, 0 );                         
       //     lastimealert1= Time[0];
       //     }
       //     }
      
       //ema_value1= iMA(NULL,PERIOD_M1,ma_periodo1,ma_shift1,ma_mode1,ma_prezzo1,i);
      // if(ma_mode1==0){MA1="SMA";}
      // if(ma_mode1==1){MA1="EMA";}
     //  if(ma_mode1==2){MA1="SMMA";}
     //  if(ma_mode1==3){MA1="LWMA";}
     //   //----
      //  ExtMapBuffer2[i] = ema_value1-Ask ;
      //  if(MathAbs(ema_value1-Bid)<=pip_distance*Point&& lastimealert!= Time[0] )
     //       {
            
      //     if(Box_Alert) Alert(Symbol()," M",Period()," Price is within ",pip_distance," pips of ",ma_periodo1," Period "+MA1+"");
     //       if(Sound_Alert) PlaySound("alert2");
   //         lastimealert= Time[0];
    //        }
   //          ema_value1= iMA(NULL,PERIOD_M5,ma_periodo1,ma_shift1,ma_mode1,ma_prezzo1,i);
   //    if(ma_mode1==0){MA1="SMA";}
   //    if(ma_mode1==1){MA1="EMA";}
   //    if(ma_mode1==2){MA1="SMMA";}
  //     if(ma_mode1==3){MA1="LWMA";}
        //----
  //      ExtMapBuffer2[i] = ema_value1-Ask ;
  //      if(MathAbs(ema_value1-Bid)<=pip_distance*Point&& lastimealert!= Time[0] )
   //         {
            
  //          if(Box_Alert) Alert(Symbol()," M",Period()," Price is within ",pip_distance," pips of ",ma_periodo1," Period "+MA1+"");
  //          if(Sound_Alert) PlaySound("alert2");
  //          lastimealert= Time[0];
            }
        }




//----
    return(0);
  }
//+------------------------------------------------------------------+


